
replace_scripts = (l) ->
  script_regex = /\[script\]\(([\w|#!:.?+=&%@!\-\/]*)\)/gi
  matches = l.match(script_regex)
  
  scripts = []
  if matches
    matches.each ->
      m = script_regex.exec(l)
      scripts.push
        short_form: m[0]
        src: m[1]
  
  scripts.each (s) ->
    l = l.replace(s.short_form, """<script src="#{s.src}" type="text/javascrip"></script>""")
  l

replace_links = (l) ->
  links_regex = /\[([\w|\s|#!:.?+=&%@!\-\/]*)\]\(([\w|#!:.?+=&%@!\-\/]*) "([\w|\s|#!:.?+=&%@!\-\/]*)"\)/gi
  matches = l.match(links_regex)
  
  links = []
  if matches
    matches.each ->
      m = links_regex.exec(l)
      links.push
        short_form: m[0]
        href: m[2]
        title: m[3]
        element: m[1]
  
  links.each (a) ->
    l = l.replace(a.short_form, """<a href="#{a.href}" title="#{a.title}">#{a.element}</a>""")
  l

mark_bold_italic = (l) ->
  tokens = l.match(/\*\*\*/g)
  if tokens          
    for i in [1..(tokens.length)]
      do ->
        tag = if i % 2 then '<b><i>' else '</i></b>'
        l = l.replace('***', tag, 1)
  l


mark_bold = (l) ->
  tokens = l.match(/\*\*/g)
  if tokens          
    for i in [1..(tokens.length)]
      do ->
        tag = if i % 2 then '<b>' else '</b>'
        l = l.replace('**', tag, 1)
  l


mark_italic = (l) ->
  tokens = l.match(/\*/g)
  if tokens          
    for i in [1..(tokens.length)]
      do ->
        tag = if i % 2 then '<i>' else '</i>'
        l = l.replace('*', tag, 1)
  l


module.exports =
  html: (text) ->
    lines = text.split('\n')
    
    html = ""
    lines.each (l) ->
      unless l == ""
        l = mark_bold_italic(l)
        l = mark_bold(l)
        l = mark_italic(l)

        l = replace_links(l)
        l = replace_scripts(l)
                
        html += """<p>#{ l }</p>"""
    
    html
  
  disqus: (conf, post) ->
    """
    <div id="disqus_thread"></div>
    <script type="text/javascript">
      var disqus_shortname = '#{conf.disqus_name}';
      var disqus_identifier = '#{post.slug}';
      var disqus_url = '#{conf.website_url}/posts/#{post.slug}';

      /* * * DON'T EDIT BELOW THIS LINE * * */
      (function() {
        var dsq = document.createElement('script'); dsq.type = 'text/javascript'; dsq.async = true;
        dsq.src = 'http://' + disqus_shortname + '.disqus.com/embed.js';
        (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(dsq);
      })();
    </script>
    """
